package me.Demon.DemonCropBuyShop;

import me.Demon.DemonCropBuyShop.Event.MarktStatsEvent;
import me.Demon.DemonCropBuyShop.Event.PlayerCropBuyEvent;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

import java.text.DecimalFormat;
import java.util.Random;

public class CropShopAPI {

    public static int getCropBuyAmount(String CorpType){
        FileConfiguration yml = Main.plugin.getConfig();
        return yml.getInt("BuyData."+CorpType);
    }

    public static void addCropBuyAmount(String CorpType,int amount){
        FileConfiguration yml = Main.plugin.getConfig();
        int a = getCropBuyAmount(CorpType) + amount;
        yml.set("BuyData."+CorpType,a);
        Main.plugin.saveConfig();
    }

    public static void setCropBuyAmount(String CorpType,int amount){
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("BuyData."+CorpType,amount);
        Main.plugin.saveConfig();
    }

    public static void SellCropsItemsEvant(Player p, String CropType, int sell_groupAmount){
        CropData dataAPI = Main.dataAPI.get(CropType);
        int price = (int) dataAPI.getMoney();
        if(sell_groupAmount >= 2){
            price = price * sell_groupAmount;
        }
        double tax = 0.05;
        if(p.hasPermission("vip2.use")){
            tax = 0.02;
        }else if(p.hasPermission("vip1.use")){
            tax = 0.03;
        }
        price = (int) (price - (price * tax));
        double taxMoney = price * tax;
        DemonAPI.giveMoney(p, price);
        p.sendMessage(Main.prefix + "你获得了: §f$" + new DecimalFormat(",###.##").format(price) + "金币 §6(纳税: " + new DecimalFormat("#.##").format(taxMoney) + "金币)");
        int sellAmount = sell_groupAmount * 64;
        if(CropType.equalsIgnoreCase("EGG")){
            sellAmount = sell_groupAmount * 16;
        }
        PlayerCropBuyEvent event = new PlayerCropBuyEvent(p, dataAPI.getCropType(), sellAmount,price,(int) taxMoney);
        Bukkit.getPluginManager().callEvent(event);
    }

    public static void Start_Updata_Event(String CropType,int type){
        // 获取CropData数据
        CropData dataAPI = Main.dataAPI.get(CropType);
        // 刷新现在价格
        double current_price = dataAPI.getMoney();
            // type == 0   系统随机
            // type == 1   上涨
            // type == 2   下跌
            if (type == 0) {
                if (current_price >= (dataAPI.getDmoney() * 1.1)) {
                    // zhenfu_1 = 越大上涨概率低
                    // zhenfu = 越小概率越高
                    System_Updata_Price(dataAPI, 40, 70, 30);
                } else if (current_price >= (dataAPI.getDmoney() * 0.8)) {
                    System_Updata_Price(dataAPI, 70, 40, 40);
                } else {
                    System_Updata_Price(dataAPI, 70, 40, 40);
                }
            } else if (type == 1) {
                if (Main.getRandomInt(100, 1) >= 70) {
                    Admin_Up_Price(dataAPI, 1);
                } else {
                    Admin_Up_Price(dataAPI, 2);
                }
            } else if (type == 2) {
                if (Main.getRandomInt(100, 1) >= 40) {
                    Admin_Down_Price(dataAPI, 1);
                } else {
                    Admin_Down_Price(dataAPI, 2);
                }
            }
    }

    public static void System_Updata_Price(CropData dataAPI,int zhenfu,int zhenfu_1,int die){
        // type = 1[涨]  2[跌]
        int mk_stats = 0;
        String new_s = "";
        // 刷新现在价格
        double server_current = dataAPI.getMoney();
        int gailv = Main.getRandomInt(100,1);
        if(gailv >= zhenfu){
            if(Main.getRandomInt(100,1) >= zhenfu_1){
                double Vmin = server_current * 0.02;
                double Vmax = server_current * 0.04;
                double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
                double price = server_current + Vprice;
                new_s = new DecimalFormat("###.##").format(price);
                mk_stats = 1;
                Bukkit.getConsoleSender().sendMessage("§6[现货交易所SY] §f农产品: "+dataAPI.getCropType()+"  状态: 震浮-涨 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
            } else {
                double Vmin = server_current * 0.03;
                double Vmax = server_current * 0.05;
                double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
                double price = server_current - Vprice;
                new_s = new DecimalFormat("###.##").format(price);
                mk_stats = 2;
                Bukkit.getConsoleSender().sendMessage("§6[现货交易所SY] §f农产品: "+dataAPI.getCropType()+"  状态: 震浮-跌 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
            }
        }else if(gailv >= die){
            // 扣除
            double Vmin = server_current * 0.01;
            double Vmax = server_current * 0.03;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current - Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            mk_stats = 1;
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所SY] §f农产品: "+dataAPI.getCropType()+"  状态: 跌 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        }else {
            double Vmin = server_current * 0.01;
            double Vmax = server_current * 0.03;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current + Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            mk_stats = 2;
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所SY] §f农产品: "+dataAPI.getCropType()+"  状态: 涨 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        }
        double xian_jia_money = Double.parseDouble(new_s);
        MarktStatsEvent event = new MarktStatsEvent(dataAPI, mk_stats,xian_jia_money);
        Bukkit.getPluginManager().callEvent(event);
    }

    public static void Admin_Up_Price(CropData dataAPI,int type){
        // type = 1[涨]  2[跌]
        int mk_stats = 1;
        String new_s = "";
        // 刷新现在价格
        double server_current = dataAPI.getMoney();
        if(type == 1){
            double Vmin = server_current * 0.02;
            double Vmax = server_current * 0.04;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current + Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所] §f农产品: "+dataAPI.getCropType()+"  状态: 震浮-涨 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        }else{
            double Vmin = server_current * 0.01;
            double Vmax = server_current * 0.03;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current + Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所] §f农产品: "+dataAPI.getCropType()+"  状态: 涨 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        }
        double xian_jia_money = Double.parseDouble(new_s);
        MarktStatsEvent event = new MarktStatsEvent(dataAPI, mk_stats,xian_jia_money);
        Bukkit.getPluginManager().callEvent(event);
    }


    public static void Admin_Down_Price(CropData dataAPI,int type){
        // type = 1[涨]  2[跌]
        int mk_stats = 2;
        String new_s = "";
        // 刷新现在价格
        double server_current = dataAPI.getMoney();
        if (type == 1) {
            double Vmin = server_current * 0.03;
            double Vmax = server_current * 0.05;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current - Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所] §f农产品: "+dataAPI.getCropType()+"  状态: 震浮-跌 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        } else {
            double Vmin = server_current * 0.01;
            double Vmax = server_current * 0.03;
            double Vprice = new Random().nextDouble()*(Vmax-Vmin)+Vmin;
            double price = server_current - Vprice;
            new_s = new DecimalFormat("###.##").format(price);
            Bukkit.getConsoleSender().sendMessage("§6[现货交易所] §f农产品: "+dataAPI.getCropType()+"  状态: 跌 "+server_current+" ---> "+new_s+"   "+getCurrenBFB(price,dataAPI.getMoney()));
        }
        double xian_jia_money = Double.parseDouble(new_s);
        MarktStatsEvent event = new MarktStatsEvent(dataAPI, mk_stats,xian_jia_money);
        Bukkit.getPluginManager().callEvent(event);
    }

    public static String getCurrenBFB(double xianjia,double last){
        double change = getCAP(xianjia,last);
        if(change >= 0) {
            return new DecimalFormat("###.##").format(change) + "%";
        }else{
            return "§c"+new DecimalFormat("###.##").format(change)+ "%";
        }
    }

    public static double getCAP(double xianjia,double last){
        double change = xianjia - last;
        return (change / last) * 100;
    }

}
