package me.Demon.DemonCropBuyShop.Event;

import me.Demon.DemonCropBuyShop.CropData;
import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

public class MarktStatsEvent extends Event {

    private static HandlerList handlers = new HandlerList();
    private CropData dataAPI;
    private int type;
    private double money;

    @Override
    public HandlerList getHandlers(){
        return handlers;
    }

    public static HandlerList getHandlerList(){
        return handlers;
    }

    public MarktStatsEvent(CropData dataAPI, int type, double money){
        this.dataAPI = dataAPI;
        this.type = type;
        this.money = money;
    }

    public CropData getDataAPI() {
        return dataAPI;
    }

    public int getType() {
        return type;
    }

    public double getMoney() {
        return money;
    }

    @Override
    public String getEventName() {
        return super.getEventName();
    }
}
