package me.Demon.DemonCropBuyShop.listener;

import me.Demon.DemonCropBuyShop.CropShopAPI;
import me.Demon.DemonCropBuyShop.Event.PlayerCropBuyEvent;
import me.Demon.DemonCropBuyShop.Main;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class PlayerCropBuy implements Listener {

    @EventHandler
    public void buyCrop(PlayerCropBuyEvent e){
        Player p = e.getPlayer();
        // 判断农作物出售数量是否大于27组~
        String cropType = e.getCroptype();
        CropShopAPI.addCropBuyAmount(cropType,e.getBuyamount());
        int sellAmount = CropShopAPI.getCropBuyAmount(cropType);
        // 若大于27组则执行市场变动
        if(sellAmount >= (getCropLimit(cropType) * 2)){
            for (String crop : Main.dataAPI.keySet()){
                if(crop.equalsIgnoreCase(cropType)){
                    CropShopAPI.Start_Updata_Event(cropType,2);
                    CropShopAPI.setCropBuyAmount(cropType,0);
                } else {
                    CropShopAPI.Start_Updata_Event(crop,1);
                }
            }
        }
    }

    public static int getCropLimit(String Crop){
        if(Crop.equalsIgnoreCase("WHEAT")){
            return 27 * 64;
        }else if(Crop.equalsIgnoreCase("POTATO_ITEM")){
            return 48 * 64;
        }else if(Crop.equalsIgnoreCase("CARROT_ITEM")){
            return 48 * 64;
        }else if(Crop.equalsIgnoreCase("MELON")){
            return 342 * 64;
        }else if(Crop.equalsIgnoreCase("PUMPKIN")){
            return 57 * 64;
        }else if(Crop.equalsIgnoreCase("CACTUS")){
            return 40 * 64;
        }else if(Crop.equalsIgnoreCase("SUGAR_CANE")){
            return 162 * 64;
        }else if(Crop.equalsIgnoreCase("NETHER_STALK")){
            return 57 * 64;
        }else if(Crop.equalsIgnoreCase("EGG")){
            return 70 * 16;
        }
        return 27 * 64;
    }
}
